package com.mh.framework.netty.task;

import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * @author LJF
 * @version 1.0
 * @project TAD_Server
 * @description 任务定时
 * @date 2023/7/3 15:34:11
 */
public class FutureTaskScheduler extends Thread{
    private ConcurrentLinkedQueue<ExecuteTask> executeTaskQueue =
            new ConcurrentLinkedQueue<>();
    private long sleepTime = 200;
    private ExecutorService pool = Executors.newFixedThreadPool(10);
    private static FutureTaskScheduler inst = new FutureTaskScheduler();
    public FutureTaskScheduler() {
        this.start();
    }
    //任务添加
    public static void add(ExecuteTask executeTask) {
        inst.executeTaskQueue.add(executeTask);
    }

    @Override
    public void run() {
        while (true) {
            handleTask();
            //threadSleep(sleepTime);
        }
    }

    private void threadSleep(long sleepTime) {
        try {
            Thread.sleep(sleepTime);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //执行任务
    private void handleTask() {
        ExecuteTask executeTask;
        while (executeTaskQueue.peek() != null) {
            executeTask = executeTaskQueue.poll();
            handleTask(executeTask);
        }
        //刷新心跳时间
    }
    private void handleTask(ExecuteTask executeTask) {
        pool.execute(new ExecuteRunnable(executeTask));
    }

    class ExecuteRunnable implements Runnable {
        ExecuteTask executeTask;
        public ExecuteRunnable(ExecuteTask executeTask) {
            this.executeTask = executeTask;
        }
        @Override
        public void run() {
            executeTask.execute();
        }
    }
}
