package com.mh.quartz.domain;

/**
 * @author LJF
 * @version 1.0
 * @project EEMCS
 * @description PID参数
 * @date 2025-05-30 13:51:22
 */
public class PIDParams {

    private volatile double kp;  // 比例系数
    private volatile double ki;  // 积分系数
    private volatile double kd;  // 微分系数

    public PIDParams(double kp, double ki, double kd) {
        this.kp = kp;
        this.ki = ki;
        this.kd = kd;
    }

    // 动态更新PID参数
    public void updateParams(double kp, double ki, double kd) {
        this.kp = kp;
        this.ki = ki;
        this.kd = kd;
    }

    public double getKp() {
        return kp;
    }

    public void setKp(double kp) {
        this.kp = kp;
    }

    public double getKi() {
        return ki;
    }

    public void setKi(double ki) {
        this.ki = ki;
    }

    public double getKd() {
        return kd;
    }

    public void setKd(double kd) {
        this.kd = kd;
    }
}
